﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using System.IO;

namespace Xenon.ForAims.Snapshot
{
    public partial class UcMain : UserControl
    {

        public UcMain()
        {
            InitializeComponent();
        }

        public void Start()
        {
            this.timer1.Start();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            Condition cond = new Condition();
            cond.Parse(this.txtRegex.Text);



            try
            {
                string filepath = this.txtFilepath.Text;
                if(File.Exists(filepath))
                {
                    StringBuilder sb = new StringBuilder();

                    string[] lines = File.ReadAllLines(filepath, Encoding.GetEncoding("Shift_JIS"));

                    Array.Sort(lines);


                    foreach (string line in lines)
                    {
                        if (cond.Match(line))
                        {
                            sb.AppendLine(line);
                        }

                    }

                    this.txtViewer.Text = sb.ToString();
                }
            }
            catch (IOException ex)
            {
            }

        }

        private void UcMain_Resize(object sender, EventArgs e)
        {
            //------------------------------------------------------------
            // ファイルパス
            //------------------------------------------------------------
            this.txtFilepath.Size = new Size(this.Size.Width - 67, this.txtFilepath.Height);

            //------------------------------------------------------------
            // 正規表現
            //------------------------------------------------------------
            this.txtRegex.Size = new Size(this.Size.Width - 67, this.txtRegex.Height);

            //------------------------------------------------------------
            // 表示部
            //------------------------------------------------------------
            this.txtViewer.Location = new Point( 0, 49 );
            this.txtViewer.Size = new Size(this.Size.Width, this.Size.Height-49 );
        }
    }
}
